package com.njcn.harmonic.api.fallback;

import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.harmonic.api.UploadGwDataFeignClient;
import com.njcn.harmonic.pojo.param.UploadDataParam;
import com.njcn.harmonic.pojo.param.UploadParam;
import com.njcn.harmonic.utils.HarmonicEnumUtil;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

/**
 * @author xuyang
 * @version 1.0.0
 * @date 2023年12月15日 13:50
 */
@Slf4j
@Component
public class UploadGwDataFallbackFactory implements FallbackFactory<UploadGwDataFeignClient> {
    @Override
    public UploadGwDataFeignClient create(Throwable throwable) {
        //判断抛出异常是否为解码器抛出的业务异常
        Enum<?> exceptionEnum = CommonResponseEnum.SERVICE_FALLBACK;
        if (throwable.getCause() instanceof BusinessException) {
            BusinessException businessException = (BusinessException) throwable.getCause();
            exceptionEnum = HarmonicEnumUtil.getExceptionEnum(businessException.getResult());
        }
        Enum<?> finalExceptionEnum = exceptionEnum;
        return new UploadGwDataFeignClient() {
            @Override
            public HttpResult<String> uploadPointStatisticalData(UploadParam param) {
                log.error("{}异常，降级处理，异常为：{}", "国网上送-主配网监测点统计数据", throwable.toString());
                return new HttpResult<>(CommonResponseEnum.FAIL.getCode(),CommonResponseEnum.FAIL.getMessage());
            }

            @Override
            public HttpResult<String> uploadSubstationStatisticalData(UploadParam param) {
                log.error("{}异常，降级处理，异常为：{}", "国网上送-变电站监测统计数据", throwable.toString());
                return new HttpResult<>(CommonResponseEnum.FAIL.getCode(),CommonResponseEnum.FAIL.getMessage());
            }

            @Override
            public HttpResult<String> uploadEvaluationData(UploadParam param) {
                log.error("{}异常，降级处理，异常为：{}", "国网上送-母线基准水平评估数据", throwable.toString());
                return new HttpResult<>(CommonResponseEnum.FAIL.getCode(),CommonResponseEnum.FAIL.getMessage());
            }

            @Override
            public HttpResult<String> upGwCommPoint(UploadDataParam param) {
                log.error("{}异常，降级处理，异常为：{}", "国网上送-公共连接点数据", throwable.toString());
                return new HttpResult<>(CommonResponseEnum.FAIL.getCode(),CommonResponseEnum.FAIL.getMessage());
            }

            @Override
            public HttpResult<String> upGwMainMonitor(UploadDataParam param) {
                log.error("{}异常，降级处理，异常为：{}", "国网上送-主网测点数据", throwable.toString());
                return new HttpResult<>(CommonResponseEnum.FAIL.getCode(),CommonResponseEnum.FAIL.getMessage());
            }
        };
    }
}
